com.smartgwt.client.widgets.drawing

## Class DrawPath

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawPath

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers
  Direct Known Subclasses:
    DrawPolygon

      public class DrawPath
      extends DrawItem

  Draws a multi-segment line.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawPath()`
    `DrawPath(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `KnobType[]` | `getKnobs()` NOTE: DrawPath items do not support knobs.
    `static DrawPath` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `Point[]` | `getPoints()` Array of Points for the line.
    `void` | `moveBy(int dX, int dY)` Move the points by dX,dY
    `void` | `moveTo(int left, int top)` Move both the start and end points of the line, such that the startPoint ends up at the specified coordinate and the line length and angle are unchanged.
    `static void` | `setDefaultProperties(DrawPath drawPathProperties)` Class level method to set the default properties of this class.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setKnobs(KnobType... knobs)` NOTE: DrawPath items do not support knobs.
    `void` | `setPoints(Point... points)` Array of Points for the line.

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getCanDrag, getCanHover, getCenter, getContextMenu, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawPane, getEndArrow, getFillColor, getFillGradient, getFillOpacity, getHoverHTML, getKeepInParentRect, getLineCap, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getRef, getResizeKnobPoints, getRotation, getScale, getShadow, getShowHover, getStartArrow, getSvgString, hide, hideKnobs, hover, isInBounds, isPointInPath, resizeBy, resizeTo, rotateBy, rotateBy, rotateTo, rotateTo, scaleBy, scaleBy, scaleTo, scaleTo, setAttribute, setCanDrag, setCanHover, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setEndArrow, setFillColor, setFillGradient, setFillOpacity, setKeepInParentRect, setKeepInParentRect, setLineCap, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setResizeKnobPoints, setRotation, setScale, setShadow, setShowHover, setStartArrow, show, showKnobs`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `asSGWTComponent, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, internalSetID, internalSetID, isCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setID, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawPath

          public DrawPath()

    - #### DrawPath

          public DrawPath(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawPath getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `DrawItem`

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### setKnobs

          public void setKnobs(KnobType... knobs)

      NOTE: DrawPath items do not support knobs.
      Overrides:
        `setKnobs` in class `DrawItem`
      Parameters:
        `knobs` - knobs Default value is null

    - #### getKnobs

          public KnobType[] getKnobs()

      NOTE: DrawPath items do not support knobs.
      Overrides:
        `getKnobs` in class `DrawItem`
      Returns:
        KnobType

    - #### setPoints

          public void setPoints(Point... points)

      Array of Points for the line.
      Parameters:
        `points` - points Default value is [[0,0], [100,100]]

    - #### getPoints

          public Point[] getPoints()

      Array of Points for the line.
      Returns:
        Point

    - #### moveBy

          public void moveBy(int dX,
                    int dY)

      Move the points by dX,dY
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `dX` - delta x coordinate in pixels
        `dY` - delta y coordinate in pixels

    - #### moveTo

          public void moveTo(int left,
                    int top)

      Move both the start and end points of the line, such that the startPoint ends up at the specified coordinate and the line length and angle are unchanged.
      Parameters:
        `left` - new startLeft coordinate in pixels
        `top` - new startTop coordinate in pixels

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawPath drawPathProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `drawPathProperties` - properties that should be used as new defaults when instances of this class are created